#include <bits/stdc++.h>
using namespace std;
const int lg=35;
int sum[lg+1];
int main()
{
    int n;scanf("%i",&n);
    int a[n+10];
    for(int i=1;i<=n;i++){
        scanf("%i",&a[i]);
        int ct=0,temp=a[i];
        while(a[i]>0){
            sum[ct]+=a[i]%2;
            a[i]/=2;
            ct++;
        }
        a[i]=temp;
    }
    int q;scanf("%i",&q);
    while(q--){
        int type;scanf("%i",&type);
        if(type==0){
            int x;scanf("%i",&x);
            int res=0;
            for(int i=0,pw=1;i<=lg;i++,pw*=2){
                if(sum[i]>=x) res+=pw;
            }
            printf("%i\n",res);
        }
        else{
            int i,x;scanf("%i%i",&i,&x);
            int ct=0;
            while(a[i]>0){
                sum[ct]-=a[i]%2;
                a[i]/=2;
                ct++;
            }
            a[i]=x;
            while(a[i]>0){
                sum[ct]-=a[i]%2;
                a[i]/=2;
                ct++;
            }
            a[i]=x;
        }
    }
    return 0;
}